routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/','PageController@index');


// =================== Proses Belanja ========================
Route::get('cart','CartController@index');
Route::post('cart','CartController@store');
Route::post('cart/checkout','CartController@checkout');
Route::delete('cart/{id}','CartController@destroy');
// =================== End Proses Belanja =====================

Route::get('/user/verify/{token}', 'Auth\RegisterController@verifyUser');
Auth::routes();
Route::get('courses','CourseController@index');
Route::get('course/{slug}','CourseController@show');
Route::get('page/verification','PageController@verification');



Route::get('play/{courseSlug}/{lessonSlug?}','CourseController@play');



// ======================== Halaman Admin =================================
Route::prefix('adminzone')->name('adminzone.')->group(function () {
    Route::resource('category','Admin\CategoryController');
    Route::resource('discount','Admin\DiscountController');
    Route::resource('course','Admin\CourseController');
    Route::get('order','Admin\OrderController@index')->name('order.index');
    Route::get('order/{invoice?}', 'Admin\OrderController@show')->where('invoice', '(.*)')->name('order.show');
    Route::put('order/{invoice?}', 'Admin\OrderController@update')->where('invoice', '(.*)')->name('order.update');
    Route::get('user/{id}/orders','Admin\UserController@orders')->name('user.orders');
    Route::get('user/member','Admin\UserController@member')->name('user.member');
    Route::get('user/{id}/follow','Admin\CourseController@follow')->name('course.follow');
    Route::resource('user','Admin\UserController');
    Route::resource('section','Admin\SectionController');
    Route::resource('lesson','Admin\LessonController');
    Route::get('login','Admin\AuthController@formLogin');
    Route::post('login','Admin\AuthController@login')->name('login');
    Route::get('logout','Admin\AuthController@logout')->name('logout');
    Route::get('dashboard','Admin\PageController@dashboard');
});
// ======================== End Halaman Admin =================================

// ======================== Endpoint API  =================================
Route::prefix('api')->name('api.')->group(function () {
    Route::get('course','Api\CourseController@index');
    Route::get('course/{slug}','Api\CourseController@show');
});
// ======================== End Endpoint API =================================


Route::get('/home', 'HomeController@index')->name('home');

app/Models/Lesson.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Lesson extends Model
{
    protected $fillable = ['title','slug','section_id','course_id','duration','video_url','description','public'];

    public function section()
    {
        return $this->belongsTo('App\Models\Section');
    }
}

app/Http/Controllers/Admin/LessonController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Repositories\Eloquent\EloquentCourseRepository;
use App\Repositories\Eloquent\EloquentLessonRepository;

class LessonController extends Controller
{
    public $lessonRepo;

    public function __construct(EloquentLessonRepository $lessonRepo)
    {
        $this->lessonRepo = $lessonRepo;
    }

    public function show($id, EloquentCourseRepository $courseRepo)
    {
        $data['course'] = $courseRepo->find($id);
        $data['sections'] = \App\Models\Section::where('course_id',$data['course']->id)->pluck('name','id');
        return view('admin.lesson.create',$data);
    }

    public function store(\App\Http\Requests\LessonCreateRequest $request)
    {
        $input          = $request->all();
        $input['slug']  = \Str::slug($request->title, '-');
        $this->lessonRepo->create($input);
        return redirect(route('adminzone.course.show',['id'=>$request->course_id]))->with('message','Success Add New Lesson With Title '.$request->title);
    }

    public function edit($id, EloquentCourseRepository $courseRepo)
    {
        $data['lesson'] = $this->lessonRepo->find($id);
        $data['section'] = $data['lesson']->section->name;
        $data['course'] = $courseRepo->findWhere('id',$data['lesson']->course_id)->first();
        $data['sections'] = \App\Models\Section::where('course_id',$data['lesson']->course_id)->pluck('name','id');
        return view('admin.lesson.edit',$data);
    }

    public function update($id,Request $request)
    {
        $input          = $request->all();
        $input['slug']  = \Str::slug($request->title, '-');
        return $input;
        $this->lessonRepo->update($id,$input);
        return redirect(route('adminzone.course.show',['id'=>$request->course_id]))->with('message','Success Add New Lesson With Title '.$request->title);
    }

    public function destroy($id)
    {
        $lesson = $this->lessonRepo->find($id);
        $this->lessonRepo->delete($id);
        return redirect(route('adminzone.course.show',['id'=>$lesson->course_id]))->with('message','A Lesson With Title '.$lesson->title.' Has Deleted');
    }
}

resources/views/admin/lesson/create.blade.php
@extends('admin.layout')
@section('title','Create Lesson')
@section('content')
<section class="content">
    <div class="container-fluid">
        <div class="card">
            <div class="card-header">
                <h3 class="card-title">Create Lesson </h3>
            </div>
            {{ Form::open(['url'=>route('adminzone.lesson.store'),'class'=>'form-horizontal'])}}
            @include('validation')
            @include('admin.lesson.form')
            </form>
        </div>
    </div>
</section>
@endsection

resources/views/admin/lesson/edit.blade.php
@extends('admin.layout')
@section('title','Edit Lesson')
@section('content')
<section class="content">
    <div class="container-fluid">
        <div class="card">
            <div class="card-header">
                <h3 class="card-title">Edit Lesson </h3>
            </div>
            {{ Form::model($lesson,['url'=>route('adminzone.lesson.update',['id'=>$lesson->id]),'class'=>'form-horizontal','method'=>'PUT'])}}
            @include('validation')
            @include('admin.lesson.form')
            </form>
        </div>
    </div>
</section>
@endsection

resources/views/admin/lesson/form.blade.php
<div class="card-body">
    <div class="form-group row">
        <label for="inputEmail3" class="col-sm-2 col-form-label">Course Name</label>
        <div class="col-sm-10">
           {{ Form::text('course_id',$course->title,['class'=>'form-control','disabled'=>'disabled'])}}
           {{ Form::hidden('course_id',$course->id)}}
        </div>
    </div>
    <div class="form-group row">
        <label for="inputEmail3" class="col-sm-2 col-form-label">Section Name</label>
        <div class="col-sm-10">
           {{ Form::select('section_id',$sections,null,['class'=>'form-control'])}}
        </div>
    </div>
    <div class="form-group row">
        <label for="inputEmail3" class="col-sm-2 col-form-label">Lesson Title</label>
        <div class="col-sm-10">
           {{ Form::text('title',null,['class'=>'form-control','placeholder'=>'Lesson Title'])}}
        </div>
    </div>
    <div class="form-group row">
        <label for="inputEmail3" class="col-sm-2 col-form-label">Public / URL / Duration</label>
        <div class="col-sm-2">
           {{ Form::select('public',[0=>'Private',2=>'Public'],null,['class'=>'form-control'])}}
        </div>
        <div class="col-sm-7">
            {{ Form::text('video_url',null,['class'=>'form-control','placeholder'=>'Video URL'])}}
         </div>
        <div class="col-sm-1">
            {{ Form::text('duration',null,['class'=>'form-control','placeholder'=>'04:50'])}}
         </div>

    </div>
    <div class="form-group row">
        <label for="inputEmail3" class="col-sm-2 col-form-label">Description</label>
        <div class="col-sm-10">
           {{ Form::textarea('description',null,['class'=>'form-control','placeholder'=>'Description'])}}
        </div>
    </div>
</div>
<div class="card-footer">
    <div class="form-group row">
        <label for="inputEmail3" class="col-sm-2 col-form-label"></label>
        <div class="col-sm-10">
            <button type="submit" class="btn btn-info"><i class="fas fa-save"></i> Save Data</button>
            <a href="{{ route('adminzone.course.show',['id'=>$course->id]) }}" class="btn btn-danger"><i class="fas fa-backward"></i> Back</a>
            @if(isset($lesson))
            {{ Form::open(['url'=>route('adminzone.lesson.destroy',['id'=>$lesson->id]),'method'=>'delete'])}}
            <button type="submit" class="btn btn-info"><i class="fas fa-trash"></i> Delete Lesson</button>
            {!! Form::close() !!}
            @endif
        </div>
    </div>
    
</div>

@push('scripts')
<script src="https://cdn.ckeditor.com/4.11.4/standard/ckeditor.js"></script>

<script>
    CKEDITOR.replace( 'description' );
</script>
@endpush